from marshmallow import Schema, fields


class WorkflowEventSchema(Schema):
    """
    Default schema for serializing WorkflowEvent.
    """
    job_name = fields.String()
    type = fields.Method("get_type", deserialize="load_type")
    timestamp = fields.DateTime()
    log = fields.String()
    retval = fields.Integer()

    # Enums apparently are not a first-class field type in Marshmallow
    def get_type(self, obj: "EventType") -> str:
        return obj.type.value

    def load_type(self, value: str) -> "EventType":
        return EventType[value]
